<template>
	<v-form ref="form" @submit.prevent="handleSubmit">
		<v-card>
			<v-card-title>Edit {{ field.name }}</v-card-title>

			<v-alert v-if="!isLoading && hasError" type="error" class="ma-4">
				An error occurred while attempting to edit a field. Please try again.
			</v-alert>

			<v-card-text class="form-content">
				<v-text-field
					label="Name"
					v-model="name"
					:rules="[isNotEmpty('Please enter the name'), hasMinimumLength(1, 'Name must be at least 1 character long')]"
					validate-on-blur
				/>
				<v-text-field label="Producer name" v-model="producerName" />
				<address-form v-model="address" />
				<contact-points-form :value="contactPoints" />
			</v-card-text>
			<v-card-actions class="px-4 pb-5 d-flex flex-wrap justify-end">
				<v-btn text rounded type="button" @click="handleClose" :disabled="isLoading">Cancel</v-btn>
				<v-btn class="ml-2" type="submit" color="primary" rounded :loading="isLoading"> Save </v-btn>
			</v-card-actions>
		</v-card>
	</v-form>
</template>

<script lang="ts">
import { defineComponent, onMounted, ref, watch } from '@vue/composition-api';
import { useEditField } from '@/store/modules/fields';
import { Address, ContactPoint, Field } from '@/store/types';
import { hasMinimumLength, isNotEmpty } from '@/utils/rules';
import AddressForm from './AddressForm.vue';
import ContactPointsForm from './ContactPointsForm.vue';

export default defineComponent({
	components: { AddressForm, ContactPointsForm },
	props: {
		field: {
			type: Object as () => Field,
			required: true,
		},
	},
	emits: ['close'],
	setup(props, { root, emit }) {
		const form = ref();
		const name = ref<string>('');
		const producerName = ref<string>('');
		const address = ref<Address | undefined>();
		const contactPoints = ref<Array<ContactPoint>>([]);
		const { editField, clearError, isLoading, hasError } = useEditField(root.$store);

		const assignValues = (field: Field) => {
			name.value = field.name;
			producerName.value = field.producerName;
			address.value = { ...field.address };
			contactPoints.value = field.contactPoints.map((contactPoint) => ({ ...contactPoint }));
		};

		const handleClose = () => {
			assignValues(props.field);
			clearError();
			form.value.resetValidation();
			emit('close');
		};

		const handleSubmit = async () => {
			clearError();

			if (!form.value.validate()) {
				return;
			}

			const success = await editField({
				id: props.field.id,
				name: name.value,
				producerName: producerName.value,
				address: address.value,
				contactPoints: contactPoints.value,
			});

			if (success) {
				root.$store.dispatch('resources/getAllResources');
				handleClose();
			}
		};

		onMounted(() => {
			assignValues(props.field);
		});

		watch(
			() => props.field,
			(field) => assignValues(field)
		);

		return {
			form,
			name,
			producerName,
			address,
			contactPoints,
			handleSubmit,
			handleClose,
			hasMinimumLength,
			isNotEmpty,
			isLoading,
			hasError,
		};
	},
});
</script>

<style lang="scss">
.form-content .v-input.v-text-field {
	margin-top: 8px;
}
</style>
